precision mediump float;

// input from glUniform's
uniform vec3      u_color;
uniform float     u_alpha;
uniform bool      u_texture_enabled;
uniform sampler2D u_texture;
uniform vec2      u_uv_offset;
uniform bool      u_uv_scale_enabled;
uniform vec2      u_uv_scale;

// input from vertex shader
in vec2 uv;

// output to GPU
layout(location=0) out vec4 fragment_color;

void main() {

    vec4 c = vec4(u_color,u_alpha);

    // texture
    if (u_texture_enabled) {
        vec2 uv2 = uv+u_uv_offset;
        if (u_uv_scale_enabled) {
            uv2 *= u_uv_scale;
        }
        c *= texture(u_texture,uv2);
    }

    fragment_color = c;
}

